#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "macro4xi.py">
#<abstract4xi abstract = "creates macros for all command messages to be embedded in dragonized programs"/>
#<refer4xi reference = "Studio4Xi"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#       > go3studio4fb <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#       Tip: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 2) check that the right input folder will be used
#      path2read4xi = VersionKB4Xi['multiprocessing4xi'] <-- check VersionKB4Xi in version4xi.py
#
# 3) > macro4xi
#   or python macro4xi.py > ..\temp\macro4xi.txt
#
# 4) ANALYZE:
# - processing of input file skeleton_print4xi.py        <-- input to create macros, others are only to create statistics about macro usage
# - folder StudioXi/c4xi/profile/developer4xi/macro4xi/  <-- output
# - macro4xi.txt                                         <-- log
#   - Macro4xi: input file: ..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//skeleton_print4xi.py
#   - ok: start-macro-tag in line:     #<macro4xi macro = "abbreviate-f">
#   - OK: MACRONAME2XI: abbreviate-f
#   - OK: END-MACRO-TAG IN LINE :     #</macro4xi>
#   - OK: OPENED FOR WRITING MACROFILE:  ..\..\..\c4xi\profile\developer4xi\macro4xi\abbreviate-f.txt
#   - OK: WROTE TO  ..\..\..\c4xi\profile\developer4xi\macro4xi\abbreviate-f.txt
#   -     message2print = "{abbreviate" + "; xxxxxxxx-abbreviate-by-yyyyyyyy: " + str(xxxxxxxx) + "; time: " + time4xi() + "}"
#   -     print4xi(class2print, method2print, message2print) 
#   - OK: CLOSED MACROFILE:  ..\..\..\c4xi\profile\developer4xi\macro4xi\abbreviate-f.txt
# ...
# =================================
# STATISTICS FOR INPUT_FILE2XI:  <_io.TextIOWrapper name='..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//skeleton_print4xi.py' mode='r' encoding='cp1252'>
# - PASSED LINES:      3198
# - START MACRO TAGS:  1172
# - END MACRO TAGS:    1172
# - SAVED MACROS:      1172
# =================================
# file:///E:/STUDIO4XI/c4xi/profile/developer4xi/macro4xi/index2verb4program.html <-- index of all verb tenses
# 
# wrote-c.txt macro which can be used to set trace about wrote operation:
#         message2print = "{wrote" + "; xxxxxxxx-wrote-by-yyyyyyyy-of-ZZZZZZZZ: " + str(xxxxxxxx)  + "; time: " + time4xi() + "}"
#         print4xi(class2print, method2print, message2print) 
# 
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'macro4py' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass

#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI
#"
#/>

# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global path2read4xi                                                 # path for input source targets

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
start_tag4xi = '<macro4xi'
end_tag4xi   = '</macro4xi>'
path2read4xi = VersionKB4Xi['multiprocessing4xi']
#"
#"/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "macro4xi" usage = "
#   creating macros
#"> 
# -------------------------------------------------------------------------------------------------
def macro4xi(param_FullName):
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------         
    
    name2xi=os.path.splitext(param_FullName)
    
    #print ('param_FullName: ' + param_FullName)
    #print ('name2xi[0]: ' + name2xi[0])
    #print ('name2xi[1]: ' + name2xi[1])
    
    # -------------------------------------------------------------------------------------------------    
    #
    # -------------------------------------------------------------------------------------------------         
      
    count_passed2xi = 0
    count_start_tag2xi = 0
    count_end_tag2xi = 0
    count_saved2xi = 0
    count_max_macrolines2xi = 33
        
    if name2xi[1] == '.py':
        # ---------------------------------------------------------------------------------------------
        # Python source files being explored
        # ---------------------------------------------------------------------------------------------    
        file2xi = name2xi[0]+'.py'
        input_file2xi = open(file2xi)
    
        # ---------------------------------------------------------------------------------------------
        # All lines in a source file
        # ---------------------------------------------------------------------------------------------
        while 1:
   
            # -----------------------------------------------------------------------------------------    
            # START OF LINE
            # -----------------------------------------------------------------------------------------     
       
 
            line2xi = input_file2xi.readline() 
            if not line2xi:

                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------     
            
                break                                                #all lines read, finish
            else:
            
                # -------------------------------------------------------------------------------------    
                # START OF LINE
                # -------------------------------------------------------------------------------------     

                count_macro_lines2xi = 0
                 
                # ------------------------------------------------------------------------------------
                # ANALYZE THE LINE
                # ------------------------------------------------------------------------------------             
                index2xi=str.find(line2xi,start_tag4xi)              # <macro4xi 
                
                if index2xi == -1:
    
                    # ---------------------------------------------------------------------------------    
                    #
                    # --------------------------------------------------------------------------------- 
                    #print ('no start-macro-tags in line: ' + line2xi)                
                    count_passed2xi = count_passed2xi + 1
                else:                                                # 012345678901234567890123456789012
                                                                     # <macro4xi macro = "initialized-f">
                    # ---------------------------------------------------------------------------------    
                    # START OF MACRO-HANDLING
                    # ---------------------------------------------------------------------------------                          
                    print ('ok: start-macro-tag in line: ' + line2xi)
                     
                    index_name_start2xi = index2xi + 19  
                    index2xi=str.find(line2xi,">")
                    if index2xi == -1:
    
                        # -----------------------------------------------------------------------------    
                        #
                        # ----------------------------------------------------------------------------- 
                    
                        print('*** ERROR: > CHARACTER IS MISSING FOR THE START TAG IN LINE: ' + line2xi)
                        count_passed2xi = count_passed2xi + 1
                        break
                    else:
                        # ----------------------------------------------------------------------------
                        # MACRO START TAG IS OK
                        # ----------------------------------------------------------------------------  
                        count_start_tag2xi = count_start_tag2xi + 1
                        index_name_end2xi = index2xi
                        macroname2xi = line2xi[index_name_start2xi:index_name_end2xi-1] #initialized-f
                        print ('OK: MACRONAME2XI: ' + macroname2xi) 
                  
                        macro2xi = ""
                        count_macro_lines2xi = 0
                         
                        while 1:
                            # ------------------------------------------------------------------------------------
                            # CREATING MACRO READING THE ACTUAL MACRO LINE(S) UNTIL MACRO END TAG
                            # ------------------------------------------------------------------------------------                            
                         
                            line2xi = input_file2xi.readline()    # message2print = "{initialized" + "; xxxxxxxx-initialized to-by-yyyyyyyy: " + str(xxxxxxxx)  + "; time: " + time4xi() + "}"
                            if not line2xi:                       # print4xi(class2print, method2print, message2print)

                                # ---------------------------------------------------------------------    
                                #
                                # ---------------------------------------------------------------------
                             
                                break                             # all lines read in file, finish
                            else:

                                # ---------------------------------------------------------------------    
                                # CONTINUING LINES FOR MACRO
                                # ---------------------------------------------------------------------
                            
                                index2xi=str.find(line2xi,end_tag4xi) # </macro4xi>
                                if index2xi == -1:

                                    # -----------------------------------------------------------------    
                                    #
                                    # -----------------------------------------------------------------  
                                             
                                    macro2xi = macro2xi + line2xi # message2print = "{initialized" + "; xxxxxxxx-initialized to-by-yyyyyyyy: " + str(xxxxxxxx)  + "; time: " + time4xi() + "}"
                                    count_macro_lines2xi = count_macro_lines2xi + 1
                                    if count_macro_lines2xi > count_max_macrolines2xi:
                                        print("*** ERROR IN FILE: ", input_file2xi)
                                        print("*** MAXIMUM NUMBER OF LINES", count_max_macrolines2xi, " EXCEEDED WITH : ", count_macro_lines2xi)
                                        print("*** LINE WHEN MAXIMUM LINES FOR A MACRO EXCEEDED: ", line2xi)
                                        count_macro_lines2xi = 0
                                        break
                                        
                                else:

                                    # -----------------------------------------------------------------    
                                    #
                                    # -----------------------------------------------------------------  
                                             
                                                             # print4xi(class2print, method2print, message2print) 
                                    print ('OK: END-MACRO-TAG IN LINE : ' + line2xi)
                                    count_end_tag2xi = count_end_tag2xi + 1
                                    break                         # </macro4xi>  

                                # ---------------------------------------------------------------------    
                                # FINISHING LINES FOR MACRO
                                # ---------------------------------------------------------------------
                                           
                            # ------------------------------------------------------------------------------------
                            # CREATED MACRO READING THE ACTUAL MACRO LINE(S) UNTIL MACRO END TAG
                            # ------------------------------------------------------------------------------------                                     
                            
                        # ------------------------------------------------------------------------------------
                        # SAVE MACRO, IF ANY
                        # ------------------------------------------------------------------------------------                      
                        if count_macro_lines2xi == 0:
                            break
                        else:
                            try:
                                macrofilepath2xi = '..\\..\\..\\c4xi\\profile\\developer4xi\\macro4xi\\' + macroname2xi + '.txt'    
                                f2xi=open(macrofilepath2xi, 'w')    
                                print("OK: OPENED FOR WRITING MACROFILE: ", macrofilepath2xi)
                                f2xi.write(macro2xi)
                                print("OK: WROTE TO ", macrofilepath2xi)
                                print(macro2xi) 
                                f2xi.close()
                                print("OK: CLOSED MACROFILE: ", macrofilepath2xi)
                                count_saved2xi = count_saved2xi + 1
                            except:
                                print("*** FAILED TO OPEN AND WRITE MACROFILE *** ")
                    # ---------------------------------------------------------------------------------    
                    # END OF MACRO-HANDLING
                    # ---------------------------------------------------------------------------------          
                # -------------------------------------------------------------------------------------    
                # END OF LINE
                # -------------------------------------------------------------------------------------     

            # -----------------------------------------------------------------------------------------    
            # EOF LINES
            # -----------------------------------------------------------------------------------------     
                        
        # ---------------------------------------------------------------------------------------------
        # END OF SOURCE FILE
        # ---------------------------------------------------------------------------------------------
        print(33*("="))
        print ("STATISTICS FOR INPUT_FILE2XI: ", input_file2xi) 
        print ('- PASSED LINES:     ', count_passed2xi)
        print ('- START MACRO TAGS: ', count_start_tag2xi)
        print ('- END MACRO TAGS:   ', count_end_tag2xi)
        print ('- SAVED MACROS:     ', count_saved2xi)
        
        if (count_start_tag2xi < count_end_tag2xi) or (count_start_tag2xi > count_end_tag2xi):
            print("*** ERROR IN FILE: ", input_file2xi)
            print("*** start-tags: ", count_start_tag2xi)
            print("*** end-tags: ", count_end_tag2xi)           

        if count_start_tag2xi == count_saved2xi:
            pass
        else:
            print("*** ERROR IN FILE: ", input_file2xi)
            print("*** START-TAGS: ", count_start_tag2xi)
            print("*** SAVED MACROS: ", count_saved2xi)              
        
        
        if count_end_tag2xi == count_saved2xi:
            pass
        else:
            print("*** ERROR IN FILE: ", input_file2xi)
            print("*** END-TAGS: ", count_end_tag2xi)
            print("*** SAVED MACROS: ", count_saved2xi)          
            
                       
        print(33*("="))
            
#</function4xi>    

# =================================================================================================
#<class4xi class = "DirectoryWalker4Xi" base = "None" child = "None" 
#   synopsis = "a forward iterator that traverses a directory tree"
#   usage = "traversing a directory tree"
#>
# =================================================================================================
class DirectoryWalker4Xi:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker4Xi"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "gets item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            try:
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # pop next directory from stack
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # got a filename
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
    
#</class4xi>        
    
# -------------------------------------------------------------------------------------------------
##<function4xi function = "main" usage = "
#   main function of macro4xi.py
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global path2read4xi
    print('=' *70)
    print("Macro4xi: creating macros from ", path2read4xi)
    print('=' *70)
    # creating macros from  ..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//    
    
    for file2xi in DirectoryWalker4Xi(path2read4xi):
        if os.path.isdir(file2xi):
            print ("Directory: " + file2xi + '\n')
        if os.path.isfile(file2xi):
            print ("Macro4xi: input file: " + file2xi + '\n')
            macro4xi(file2xi)
    
    print('=' *70)
    print("Created all macros to folder ..//..//..//..//StudioXi//c4xi//profile//developer4xi//macro4xi//")
    print('=' *70)

#</function4xi>    
    
        
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   macro4xi.txt

# 
# ======================================================================
# Created all macros to folder E://StudioXi//c4xi//profile//developer4xi//macro4xi//
# ======================================================================

# Macro4xi: input file: E://sw4xi//python33//Lib//multiprocessing4xi//skeleton_print4xi.py 
# 
# ok: start-macro-tag in line:     #<macro4xi name = aced-f>
# 
# ok: macroname2xi: aced-f
# ok: end-macro-tag in line :     #</macro4xi>
# 
# ok: opened for writing macrofile:  ..\..\..\c4xi\profile\developer4xi\macro4xi\aced-f.txt
# ok: wrote to  ..\..\..\c4xi\profile\developer4xi\macro4xi\aced-f.txt
#     message2print = "{aced" + "; xxxxxxxx-aced-by-yyyyyyyy: " + str(xxxxxxxx) + "; time: " + time4xi() + "}"
#     print4xi(class2print, method2print, message2print) 
# 
# ok: closed macrofile:  ..\..\..\c4xi\profile\developer4xi\macro4xi\aced-f.txt
# 
# .....
# =================================
# Statistics for input_file2xi:  <_io.TextIOWrapper name='E://sw4xi//python33//Lib//multiprocessing4xi//skeleton_print4xi.py' encoding='cp1252'>
# - passed lines:      1643
# - start macro tags:  379
# - end macro tags:    379
# - saved macros:      379
# =================================
# 
# ...
# 
# # =================================
# # Statistics for input_file2xi:  <_io.TextIOWrapper name='E://sw4xi//python33//Lib//multiprocessing4xi//socketclient2xi.py' encoding='cp1252'>
# # - passed lines:      50
# # - start macro tags:  0
# # - end macro tags:    0
# # - saved macros:      0
# # =================================
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of macro4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>
